import 'dart:math' as math;
import 'dart:io' as io;
import 'population2.dart';
import 'agent2.dart';
import 'dimension2.dart';

class DE {
  DE() {
    random = new math.Random();
    population = new List();
    pop = new Population();
  }
  // DE constructor
  static var f = new io.File("aus.txt");

  /// list of generated populations
  List<Agent> population;
  Population pop;

  /// populiation size to generate at the begining
  int POPULATION_SIZE = 200;

  /// crossover probability [0,1]
  num CROSSOVER_PROBABILITY = 0.4;

  /// differential weight [0,2]
  num DIFFERENTIAL_WEIGHT = 1.2;

  /// number of iteration
  int ITERATION_NO = 50;

  /// random number generator
  math.Random random;

  PrintWriter pw;

  /// fitness function
  num fitFunction(Agent aCandidate) {
    /* 

    // Rastrigin function
    num value = 10.0 * aCandidate.dataValue.length;

    for (int i = 0; i < aCandidate.dataValue.length; i++) {
      value = value +
          math.pow(aCandidate.dataValue[i], 2.0) -
          10.0 * math.cos(2 * 3.1415 * aCandidate.dataValue[i]);
    }

    */
    var dv0 = aCandidate.dataValue[0] - 1;
    var dv1 = aCandidate.dataValue[1] - 1;
    var dv2 = aCandidate.dataValue[2] - 1;

    num value = dv0 * dv0 + dv1 * dv1 + dv2 * dv2;

    //        double[] values = aCandidate.dataValue;
    //        double value = 100 * Math.pow(Math.pow(values[0], 2) - values[1], 2) + Math.pow(1 - values[0], 2);

    return value;
  }

  /// Optimization-Algorithm in Class DE
  Agent optimise(List<Dimension> dimensionList) {
    // Step 1:
    // generate initial population up to the define limit
    for (int i = 0; i < POPULATION_SIZE; i++) {
      Agent individual = new Agent(dimensionList);
      population.add(individual);
    }

    for (int i = 0; i < POPULATION_SIZE; i++) {
      pop.add(new Agent(dimensionList));
    }

    // try more than one iteration
    for (int iterationCount = 0;
        iterationCount < ITERATION_NO;
        iterationCount++) {
      /*     
      print("\n");
      int IndCount= 0;
      for (Agent individual in population) {
        print( "popoluation: " + iterationCount.toString() + "  Indiv: "  +  IndCount.toString() + " Vars: " + individual.toString() + "  Fit " +  fitFunction(individual).toString());
        IndCount++;
      }
      */

      /*
      try {
        pw = new PrintWriter(
            "popoluation_" + iterationCount.toString() + ".csv");
      } catch (e) {}

      for (int n = 0; n < dimensionList.length; n++) {
        pw.write("v" + n.toString());
        pw.write(",");
      }

      pw.write("fValue");

      pw.write("\n");

      for (Agent individual in population) {
        pw.write(individual.toString());
        pw.write(",");
        pw.write(fitFunction(individual).toString());
        pw.write("\n");
      }

      pw.flush();
      */

      /// Number of Iterations
      int loop = 0;

      // main loop for evolution
      // die Population wird durchlaufen
      while (loop < population.length) {
        Agent original;
        Agent candidate;
        bool boundsHappy;

        do {
          boundsHappy = true;
          // pick one agent  from the population, in the end all agents will have been picked
          int x = loop;
          // pick threee other aggents from Pop
          int a, b, c = -1;

          /////////////////////////////
          // clone process
          //
          // pick three different random agents from the population
          // make sure that they are not identical to selected agent from
          // the population

          // hier werden nur die Indizes ausgewählt
          // x wurde schon ausgewählt
          // a muss anders als x sein
          do {
            a = random.nextInt(population.length);
          } while (x == a);
          // b muss anders als a und x sein
          do {
            b = random.nextInt(population.length);
          } while (b == x || b == a);

          do {
            c = random.nextInt(population.length);
          } while (c == x || c == a || c == b);

          Agent individual1 = population[a];
          Agent individual2 = population[b];
          Agent individual3 = population[c];

          /// now 3 + 1 Agents are picked
          ///
          // Now create one noisy random candidate
          Agent noisyRandomCandicate = new Agent(dimensionList);

          ///////////////////
          // mutation process:
          //
          // adjust noise candidate
          for (int n = 0; n < dimensionList.length; n++) {
            noisyRandomCandicate.dataValue[n] = (individual1.dataValue[n] +
                DIFFERENTIAL_WEIGHT *
                    (individual2.dataValue[n] - individual3.dataValue[n]));
          }

          //////////////////////////////////////
          // selection process
          //
          // Create a trial candicate
          original = population[x]; // actual candidate
          candidate = new Agent(dimensionList);

          // initialize values of candidate with values from original agent
          for (int n = 0; n < dimensionList.length; n++) {
            candidate.dataValue[n] = original.dataValue[n];
          }

          // crossver process with the selected individual
          // pick a random dimension, which defintely takes the value from the noisy random candidate
          int R = random.nextInt(dimensionList.length);

          for (int n = 0; n < dimensionList.length; n++) {
            double crossoverProbability = random.nextDouble();

            if (crossoverProbability < CROSSOVER_PROBABILITY || n == R) {
              candidate.dataValue[n] = noisyRandomCandicate.dataValue[n];
            }
          }

          // check here if the trial candiate satisfies bounds for each value
          for (int n = 0; n < dimensionList.length; n++) {
            if (candidate.dataValue[n] < dimensionList[n].lower ||
                candidate.dataValue[n] > dimensionList[n].upper) {
              boundsHappy = false;
            }
          }
        } while (boundsHappy == false);

        //see if the candidate is better than original, if so replace it
        if (fitFunction(original) < fitFunction(candidate)) {
          population.remove(original);
          population.add(candidate);
        }
        loop++;
      }
    }

    // selecting the final best agent from the the population
    Agent bestFitness = new Agent(dimensionList);

    population.forEach((Agent agent) {
      if (fitFunction(bestFitness) < fitFunction(agent)) {
        bestFitness = agent.clone();
      }
    });

    return bestFitness;
  }
}

class PrintWriter {
  PrintWriter(String filename) {
    this.fil = io.File(filename);
  }
  io.File fil;

  void flush() {}
  void write(String contents) {
    this.fil.writeAsStringSync(contents);
  }
}

mixin Ds implements List {}
